package cpcns.danganzhengli.shiwu.contoller;

package .tmp;

import cpcns.baoguanqixiancelue.service.IGQuanZongWeiHuService;
import cpcns.base.common.User;
import cpcns.base.common.util.JsonWithJacksonUtils;
import cpcns.base.configuration.AppConfiguration;
import cpcns.base.generic.ResultMessage;
import cpcns.common.controller.commonController;
import cpcns.common.service.ICommonService;
import cpcns.danganmenlei.model.GDangAnMenLei;
import cpcns.danganmenlei.service.IGDangAnMenLeiService;
import cpcns.danganzhengli.shiwu.model.DShiWu;
import cpcns.danganzhengli.shiwu.service.IShiWuService;
import cpcns.printManager.PrintUtil;
import cpcns.utils.CommStatic;
import cpcns.utils.PagerVO;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.sf.json.JSONObject;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@RequestMapping({"/ShiWuController"})
@Controller
public class ShiWuController extends commonController {
  @Autowired
  private IShiWuService shiWuService;
  
  @Autowired
  private ICommonService commonService;
  
  @Autowired
  private IGDangAnMenLeiService gDangAnMenLeiService;
  
  @Autowired
  private IGQuanZongWeiHuService quanZongWeiHuService;
  
  @RequestMapping({"/query"})
  public String query(HttpServletRequest request, HttpServletResponse response, Model model) {
    String menLei = request.getParameter("menLei");
    model.addAttribute("menLei", menLei);
    return "danganzhengli/shiwu/ShiWuList";
  }
  
  @RequestMapping({"/newAdd"})
  public String newAdd(HttpServletRequest request, HttpServletResponse response) {
    String hangBiaoShi = getRequest().getParameter("hangBiaoShi");
    DShiWu dShiWu = new DShiWu();
    if (StringUtils.isNotBlank(hangBiaoShi)) {
      dShiWu = (DShiWu)this.shiWuService.getById(Integer.valueOf(Integer.parseInt(hangBiaoShi)));
      GDangAnMenLei dam = this.gDangAnMenLeiService.getByFenLeiHao(dShiWu.getMenLei());
      if (dam != null) {
        getRequest().setAttribute("dangHaoGuiZe", dam.getDangHaoGuiZe());
        getRequest().setAttribute("fenGeFu", dam.getFenGeFu());
        getRequest().setAttribute("xuHaoGuiZe", dam.getZiFuDaiMa());
        getRequest().setAttribute("qiDongDangHao", dam.getQiDongDangHao());
      } 
      String keyWordResult = getRequest().getParameter("keyWordResult");
      getRequest().setAttribute("keyWordResult", keyWordResult);
      this.shiWuService.addDA_RiZhi(getCurrentUser(), this.server, "D_ShiWu", dShiWu.getHangBiaoShi(), String.valueOf(dShiWu.getBiaoTi()) + "$." + dShiWu.getDangHao() + "$." + dShiWu.getMenLei(), "查看");
    } else {
      String menLei = getRequest().getParameter("menLei");
      User use = getCurrentUser();
      String[] bm = use.getBuMenMingChengs().split(" ");
      String[] bs = use.getBuMenBiaoShi().split(" ");
      GDangAnMenLei dam = this.gDangAnMenLeiService.getByFenLeiHao(menLei);
      if (dam != null) {
        getRequest().setAttribute("dangHaoGuiZe", dam.getDangHaoGuiZe());
        getRequest().setAttribute("fenGeFu", dam.getFenGeFu());
        getRequest().setAttribute("xuHaoGuiZe", dam.getZiFuDaiMa());
        getRequest().setAttribute("qiDongDangHao", dam.getQiDongDangHao());
      } 
      dShiWu.setQuanZongHao(use.getQuanZongHao());
      dShiWu.setBaoGuanQiXian("Y");
      dShiWu.setZhuangTai(Integer.valueOf(0));
      dShiWu.setJieYueZhuangTai(Integer.valueOf(0));
      dShiWu.setKaiFangZhuangTai(Integer.valueOf(0));
      dShiWu.setMenLei(request.getParameter("menLei"));
      if (bm != null && bm.length > 1)
        dShiWu.setGuiDangBuMenMingCheng(bm[1]); 
      if (bs != null && bs.length > 1)
        dShiWu.setGuiDangBuMenBiaoShi(Integer.valueOf(Integer.parseInt(bs[1]))); 
      dShiWu.setGuiDangRenMingCheng(use.getMingCheng());
      dShiWu.setGuiDangRenBiaoShi(use.getBiaoShi());
      dShiWu.setDjrq((new SimpleDateFormat("yyyy-MM-dd")).format(new Date()));
    } 
    String pathPre = AppConfiguration.getConfigValue("CPCNS0412_DangAnFuJian");
    getRequest().setAttribute("pathPre", pathPre);
    getRequest().setAttribute("dShiWu", dShiWu);
    return "danganzhengli/shiwu/ShiWuEdit";
  }
  
  @RequestMapping({"/copy.do"})
  public void copy(HttpServletRequest request, HttpServletResponse response) {
    DShiWu dShiWu = new DShiWu();
    User use = getCurrentUser();
    String[] bm = use.getBuMenMingChengs().split(" ");
    String[] bs = use.getBuMenBiaoShi().split(" ");
    dShiWu.setZhuangTai(Integer.valueOf(0));
    dShiWu.setJieYueZhuangTai(Integer.valueOf(0));
    dShiWu.setKaiFangZhuangTai(Integer.valueOf(0));
    if (bm != null && bm.length > 1)
      dShiWu.setGuiDangBuMenMingCheng(bm[1]); 
    if (bs != null && bs.length > 1)
      dShiWu.setGuiDangBuMenBiaoShi(Integer.valueOf(Integer.parseInt(bs[1]))); 
    dShiWu.setGuiDangRenMingCheng(use.getMingCheng());
    dShiWu.setGuiDangRenBiaoShi(use.getBiaoShi());
    dShiWu.setDjrq((new SimpleDateFormat("yyyy-MM-dd")).format(new Date()));
    String S = JsonWithJacksonUtils.getInstance().obj2Json(dShiWu);
    responseWriter(response, S);
  }
  
  @RequestMapping({"/getAll.do"})
  public String getAll(HttpServletRequest request, HttpServletResponse response) throws IOException {
    Enumeration<?> rnames = getRequest().getParameterNames();
    JSONObject jsonObject = new JSONObject();
    for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
      String thisName = er.nextElement().toString();
      String thisValue = getRequest().getParameter(thisName);
      if (!"querystr".equals(thisName))
        jsonObject.put(thisName, thisValue); 
    } 
    String importTool = getRequest().getParameter("importTool");
    User user = getCurrentUser();
    StringBuffer sqlWhere = new StringBuffer(" 1=1 and zhuangTai not in (3,4,6) ");
    if (StringUtils.isNotBlank(importTool) && importTool.equals("importTool")) {
      sqlWhere = new StringBuffer(" 1=1 and zhuangTai in (6) ");
    } else {
      boolean fl = this.commonService.getInitVal("chaXunQuanXianKongZhi", "chaXunQuanXianKongZhi");
      if (fl) {
        Map<String, String> tjmap = new HashMap<>();
        String quanZongHao = request.getParameter("quanZongHao");
        String checkbox = (getRequest().getParameter("checkbox") == null) ? "false" : getRequest().getParameter("checkbox");
        String all_qz = this.quanZongWeiHuService.getAllQzuanZhong(user.getQuanZongHao());
        tjmap.put("guanLianQuanZong", all_qz);
        tjmap.put("checkbox", checkbox);
        tjmap.put("quanZongHao", quanZongHao);
        tjmap.put("table", this.table);
        sqlWhere.append(CommStatic.IsQuanXian(user, AppConfiguration.getConfigValue("CPCNS_XITONGLEIXING"), tjmap));
      } 
    } 
    Iterator<String> iterator = jsonObject.keys();
    while (iterator.hasNext()) {
      String key = iterator.next();
      String value = jsonObject.getString(key);
      if (value != null && !value.trim().equals("") && !key.equals("page") && !key.equals("rows") && !"order".equals(key) && !"sort".equals(key) && !"type".equals(key) && !"leiXing".equals(key) && !"zuHeType".equals(key) && !"nd".equals(key) && !"importTool".equals(key)) {
        if (key.contains("begin")) {
          key = key.substring(0, key.indexOf("begin"));
          sqlWhere.append(" and ").append(
              String.valueOf(key) + " >= to_date('" + value + "','yyyy-mm-dd') ");
          continue;
        } 
        if (key.contains("end")) {
          key = key.substring(0, key.indexOf("end"));
          sqlWhere.append(" and ").append(
              String.valueOf(key) + " <= to_date('" + value + "','yyyy-mm-dd') ");
          continue;
        } 
        if (!"server".equals(key) && !"table".equals(key) && !"checkbox".equals(key)) {
          if (!key.contains("like")) {
            if (key.equals("guiDangNianDu")) {
              String nd = getRequest().getParameter("nd");
              if (StringUtils.isNotBlank(nd)) {
                sqlWhere.append(" and ").append(key).append(" ").append(nd).append("'").append(value).append("'");
                continue;
              } 
              sqlWhere.append(" and ").append(key).append(" = '").append(value).append("'");
              continue;
            } 
            sqlWhere.append(" and ").append(String.valueOf(key) + " = '" + value + "'");
            continue;
          } 
          key = key.substring(0, key.indexOf("like"));
          sqlWhere.append(" and ").append(String.valueOf(key) + " like " + "'%" + value.trim() + "%'");
        } 
      } 
    } 
    String querySt = request.getParameter("querystr");
    String zuHeType = request.getParameter("zuHeType");
    if (StringUtils.isNotBlank(querySt)) {
      sqlWhere.append(" ").append(CommStatic.zhuHeQueryJieXi_new(querySt, zuHeType, getDataType()));
      sqlWhere.append(" and zhuangTai not in (3,4,6) ");
    } 
    String page = request.getParameter("page");
    String rows = request.getParameter("rows");
    int intPage = Integer.parseInt((page == null || page == "0") ? "0" : page);
    int number = Integer.parseInt((rows == null || rows == "0") ? "0" : rows);
    int start = (intPage - 1) * number;
    String menLei = request.getParameter("menLei");
    String paixutiaojian = this.shiWuService.paiXuTiaoJian(String.valueOf(this.table.toUpperCase()) + "_" + menLei);
    if (StringUtils.isBlank(paixutiaojian))
      paixutiaojian = "quanZongHao,guiDangNianDu,baoGuanQiXian,xuHao asc"; 
    System.out.println(paixutiaojian);
    StringBuffer sql = new StringBuffer("select quanZongHao,hangBiaoShi,xuHao,biaoTi,dangHao,miJi,baoGuanQiXian,guiDangNianDu,leiBie,fenLeiMingCheng,zhuangTai,yiJiaoPiCi,zeRenZhe,menLei,shouYuriQi,geShu,kuFangWeiZhi,huoJiangDanWei from D_shiWu where ");
    PagerVO pagevo = this.shiWuService.getAll(start, number, sql.toString(), sqlWhere.toString(), CommStatic.getOrderBy(request, paixutiaojian));
    String jsonString = JsonWithJacksonUtils.getInstance().obj2Json(pagevo);
    jsonString = jsonString.replaceAll("HANGBIAOSHI", "hangBiaoShi").replaceAll("BIAOTI", "biaoTi").replaceAll("DANGHAO", "dangHao")
      .replaceAll("LEIBIE", "leiBie").replaceAll("GUIDANGNIANDU", "guiDangNianDu").replaceAll("ZERENZHE", "zeRenZhe")
      .replaceAll("DENGJIRIQI", "dengJiRiQi").replaceAll("ZHUANGTAI", "zhuangTai").replaceAll("FENLEIMINGCHENG", "fenLeiMingCheng")
      .replaceAll("SHOUYURIQI", "shouYuRiQi").replaceAll("HUOJIANGDANWEI", "huoJiangDanWei").replaceAll("YIJIAOPICI", "yiJiaoPici")
      .replaceAll("GESHU", "geShu").replaceAll("KUFANGWEIZHI", "kuFangWeiZhi");
    write(response, jsonString);
    return null;
  }
  
  @RequestMapping({"/save.do"})
  @ResponseBody
  public void saveShiWu(HttpServletRequest request, HttpServletResponse response) {
    ResultMessage rm = new ResultMessage();
    String info = "";
    Enumeration<?> rnames = getRequest().getParameterNames();
    JSONObject jsonObject = new JSONObject();
    for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
      String thisName = er.nextElement().toString();
      String thisValue = getRequest().getParameter(thisName);
      if ("guanLianBiaoShi".equals(thisName))
        thisValue = "0"; 
      jsonObject.put(thisName, thisValue);
    } 
    DShiWu t = (DShiWu)JsonWithJacksonUtils.getInstance().json2Obj(jsonObject.toString(), DShiWu.class);
    if (t != null) {
      String rizhiInfo = "修改";
      if (t.getHangBiaoShi() == null || t.getHangBiaoShi().equals("")) {
        t.setHangBiaoShi(Integer.valueOf(this.shiWuService.getPk()));
        rizhiInfo = "新增";
        try {
          this.shiWuService.save(t);
        } catch (Exception e) {
          e.printStackTrace();
          info = "保存失败！";
          t.setHangBiaoShi(Integer.valueOf(this.shiWuService.getPk()));
          this.shiWuService.save(t);
        } 
      } else {
        this.shiWuService.update(t);
      } 
      try {
        rm.setSuccess(true);
        rm.addResultMessage("hangBiaoShi", t.getHangBiaoShi());
        info = "保存成功！";
        this.shiWuService.addDA_RiZhi(getCurrentUser(), this.server, "D_ShiWu", t.getHangBiaoShi(), String.valueOf(t.getBiaoTi()) + "$." + t.getDangHao() + "$." + t.getMenLei(), rizhiInfo);
      } catch (Exception e) {
        e.printStackTrace();
        info = "保存失败，请联系管理员！";
        rm.setSuccess(false);
      } 
    } 
    rm.setInfo(info);
    responseWriter(response, rm.toString());
  }
  
  @RequestMapping({"/delete.do"})
  @ResponseBody
  public void delete(HttpServletRequest request, HttpServletResponse response) {
    String hangBiaoShi = getRequest().getParameter("hangBiaoShi");
    ResultMessage rm = new ResultMessage();
    if (StringUtils.isNotBlank(hangBiaoShi)) {
      String[] hbs = hangBiaoShi.split(",");
      byte b;
      int i;
      String[] arrayOfString1;
      for (i = (arrayOfString1 = hbs).length, b = 0; b < i; ) {
        String hb = arrayOfString1[b];
        DShiWu t = (DShiWu)this.shiWuService.getById(Integer.valueOf(Integer.parseInt(hb)));
        this.shiWuService.addDA_RiZhi(getCurrentUser(), this.server, "D_ShiWu", t.getHangBiaoShi(), String.valueOf(t.getBiaoTi()) + "$." + t.getDangHao() + "$." + t.getMenLei(), "删除");
        b++;
      } 
      this.commonService.deleteByUser(getCurrentUser(), getServer(), "D_ShiWu", hangBiaoShi);
      rm.setSuccess(true);
      rm.setInfo("删除成功！");
    } else {
      rm.setSuccess(false);
      rm.setInfo("删除失败，选择的记录无效！");
    } 
    responseWriter(response, rm.toString());
  }
  
  @RequestMapping({"/swGuiDang.do"})
  @ResponseBody
  public void yxGuiDang(HttpServletRequest request, HttpServletResponse response) {
    String hangBiaoShi = getRequest().getParameter("hangBiaoShis");
    String value = getRequest().getParameter("value");
    String info = "";
    if (StringUtils.isNotBlank(hangBiaoShi) && StringUtils.isNotBlank(value)) {
      String rizhiInfo = "";
      StringBuffer sql = new StringBuffer();
      Date date = new Date();
      SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
      String time = format.format(date);
      if ("1".equals(value)) {
        sql.append("update D_ShiWu set zhuangTai=1 ,guiDangRiQi= to_date('" + time + "','yyyy-mm-dd') where hangBiaoShi in (" + hangBiaoShi + ")");
        rizhiInfo = "归档";
      } else if ("2".equals(value)) {
        sql.append("update D_ShiWu set zhuangTai=0 ,guiDangRiQi=" + null + " where hangBiaoShi in (" + hangBiaoShi + ")");
        rizhiInfo = "取消归档";
      } 
      if (StringUtils.isNotBlank(sql.toString())) {
        this.shiWuService.update(sql.toString());
        info = "500";
      } 
      String[] hbs = hangBiaoShi.split(",");
      byte b;
      int i;
      String[] arrayOfString1;
      for (i = (arrayOfString1 = hbs).length, b = 0; b < i; ) {
        String hb = arrayOfString1[b];
        DShiWu t = (DShiWu)this.shiWuService.getById(Integer.valueOf(Integer.parseInt(hb)));
        this.shiWuService.addDA_RiZhi(getCurrentUser(), this.server, "D_ShiWu", t.getHangBiaoShi(), String.valueOf(t.getBiaoTi()) + "$." + t.getDangHao() + "$." + t.getMenLei(), rizhiInfo);
        b++;
      } 
    } 
    responseWriter(response, info);
  }
  
  @RequestMapping({"/creatxuHao.do"})
  @ResponseBody
  public String creatxuHao(HttpServletRequest request, HttpServletResponse response) {
    Integer xh = Integer.valueOf(1);
    try {
      Map<String, String> map = CommStatic.getRequestParams(request);
      xh = Integer.valueOf(Integer.parseInt(this.commonService.shengChengHao(map)));
    } catch (Exception exception) {}
    return String.valueOf(xh);
  }
  
  @RequestMapping({"/swmuluPrint.do"})
  public String swmuluPrint(HttpServletRequest request, HttpServletResponse response) {
    try {
      User user = getCurrentUser();
      String ml = getRequest().getParameter("menLei");
      String fenLei = getRequest().getParameter("fenLei");
      String guiDangNianDu = getRequest().getParameter("guiDangNianDu");
      String leiXing = getRequest().getParameter("leiXing");
      String hangBiaoShi = getRequest().getParameter("hangBiaoShi");
      String leiBie = getRequest().getParameter("leiBie");
      String fenLeiMingCheng = getRequest().getParameter("fenLeiMingCheng");
      StringBuilder sql = new StringBuilder("select xuhao,danghao,quanZongHao,fenleimingcheng,biaoti,shouyuriqi,kufangweizhi,zerenzhe,huoJiangDanWei from D_SHIWU  where zhuangtai!=3");
      if (StringUtils.isNotBlank(guiDangNianDu))
        sql.append(" and guiDangNianDu=").append(guiDangNianDu); 
      if (StringUtils.isBlank(fenLei)) {
        fenLei = "";
      } else {
        sql.append(" and fenLei=").append(fenLei);
      } 
      if (StringUtils.isNotBlank(hangBiaoShi))
        sql.append(" and hangBiaoShi in (").append(hangBiaoShi).append(")"); 
      if (StringUtils.isNotBlank(leiBie))
        sql.append(" and leiBie = '").append(leiBie).append("'"); 
      if (StringUtils.isNotBlank(fenLeiMingCheng))
        sql.append(" and fenLeiMingCheng = '").append(fenLeiMingCheng).append("'"); 
      sql.append(" order by xuHao asc ");
      List<Map<String, Object>> list = this.commonService.getListSQL(sql.toString());
      HashMap<String, Object> params = new HashMap<>();
      String model = "swmulu.jasper";
      String printService = AppConfiguration.getConfigValue("printServlet");
      list = CommStatic.print_BuKongXing(list, 10);
      PrintUtil.printService(request, user, printService, model, list, params, "swml");
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return "print/check";
  }
  
  @RequestMapping({"/swbqPrint.do"})
  public String swbqPrint(HttpServletRequest request, HttpServletResponse response) {
    try {
      User user = getCurrentUser();
      String ml = getRequest().getParameter("menLei");
      String hangBiaoShi = getRequest().getParameter("hangBiaoShi");
      StringBuilder sql = new StringBuilder("select quanzonghao,zerenzhe,xuhao,shouyuriqi,biaoti from D_SHIWU  where 1=1 ");
      sql.append(" and hangBiaoshi = ").append(hangBiaoShi);
      HashMap<String, Object> params = new HashMap<>();
      List<Map<String, Object>> list = this.commonService.getListSQL(sql.toString());
      if (list != null && list.size() > 0)
        for (int i = 0; i < list.size(); i++) {
          Map<String, Object> smap = list.get(i);
          String vu = (String)smap.get("SHOUYURIQI");
          if (StringUtils.isNotBlank(vu)) {
            String[] cyrq_ = vu.split(" ");
            params.put("SHOUYURIQI", cyrq_[0]);
          } else {
            params.put("SHOUYURIQI", "");
          } 
          vu = (String)smap.get("QUANZONGHAO");
          if (StringUtils.isNotBlank(vu)) {
            params.put("QUANZONGHAO", vu);
          } else {
            params.put("QUANZONGHAO", "");
          } 
          vu = (String)smap.get("ZERENZHE");
          if (StringUtils.isNotBlank(vu)) {
            params.put("ZERENZHE", vu);
          } else {
            params.put("ZERENZHE", "");
          } 
          vu = (String)smap.get("XUHAO");
          if (StringUtils.isNotBlank(vu)) {
            params.put("XUHAO", vu);
          } else {
            params.put("XUHAO", "");
          } 
          vu = (String)smap.get("BIAOTI");
          if (StringUtils.isNotBlank(vu)) {
            params.put("BIAOTI", vu);
          } else {
            params.put("BIAOTI", "");
          } 
        }  
      String model = "swbq.jasper";
      String printService = AppConfiguration.getConfigValue("printServlet");
      PrintUtil.printService(request, user, printService, model, list, params, "swbq");
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return "print/check";
  }
  
  @RequestMapping({"/validationShiWuJH.do"})
  public void validationShiWuJH(HttpServletResponse response) {
    String xuHao = getRequest().getParameter("xuHao");
    String hangBiaoShi = getRequest().getParameter("hangBiaoShi");
    String guiDangNianDu = getRequest().getParameter("guiDangNianDu");
    String quanZongHao = getRequest().getParameter("quanZongHao");
    String fenLeiMingCheng = getRequest().getParameter("fenLeiMingCheng");
    String msg = "500";
    if (StringUtils.isNotBlank(xuHao)) {
      StringBuffer sqlWHERE = new StringBuffer("select hangBiaoShi from D_ShiWu where xuHao = '" + xuHao + "' and guiDangNianDu=" + guiDangNianDu + " and quanZongHao = '" + quanZongHao + "' ");
      sqlWHERE.append("\tand zhuangTai not in(3,4)");
      sqlWHERE.append("\tand fenLeiMingCheng ='" + fenLeiMingCheng + "'");
      if (StringUtils.isNotBlank(hangBiaoShi))
        sqlWHERE.append(" and hangBiaoShi != " + hangBiaoShi); 
      boolean pagevo = this.commonService.checkInfo(this.server, sqlWHERE.toString());
      if (!pagevo)
        msg = "600"; 
    } 
    responseWriter(response, msg);
  }
}
